﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamGridErrorInfo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<Product> data = new ObservableCollection<Product>();
            data.Add(new Product() { Name = "product1", SKU = "item1" });
            data.Add(new Product() { Name = "product2", SKU = "item2" });
            data.Add(new Product() { Name = "product3", SKU = "item3" });
            this.DataContext = data;
        }
    }

    public class Product : INotifyPropertyChanged, IDataErrorInfo
    {

        public Product()
        {
        }

        private string sku;
        public string SKU
        {
            get
            {
                return this.sku;
            }
            set
            {
                if (this.sku != value)
                {
                    this.sku = value;
                    this.NotifyPropertyChanged("SKU");
                }
            }
        }

        private string name;
        public string Name
        {
            get
            {
                return this.name;
            }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    this.NotifyPropertyChanged("Name");
                }

            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        public string Error
        {
            get { return null; }
        }

        public string this[string columnName]
        {
            get
            {
                if (Name!= null)
                {
                    if (Name.Length <= 5)
                    {
                        return "Length must be greater than 5";
                    }
                }                
                return null;
            }

        }
    }
}
